Package org.eclipse.swt.custom

## Class StackLayout

- java.lang.Object
- - org.eclipse.swt.widgets.Layout
  - - org.eclipse.swt.custom.StackLayout

    public class StackLayout
    extends Layout

This Layout stacks all the controls one on top of the other and resizes all controls to have the same size and location. The control specified in topControl is visible and all other controls are not visible. Users must set the topControl value to flip between the visible items and then call layout() on the composite which has the StackLayout.

Here is an example which places ten buttons in a stack layout and flips between them:

     public static void main( String[] args ) {
       Display display = new Display();
       Shell shell = new Shell( display );
       shell.setLayout( new GridLayout() );
       final Composite parent = new Composite( shell, SWT.NONE );
       parent.setLayoutData( new GridData( GridData.FILL_BOTH ) );
       final StackLayout layout = new StackLayout();
       parent.setLayout( layout );
       final Button[] bArray = new Button[ 10 ];
       for( int i = 0; i < 10; i++ ) {
         bArray[ i ] = new Button( parent, SWT.PUSH );
         bArray[ i ].setText( "Button " + i );
       }
       layout.topControl = bArray[ 0 ];
       Button b = new Button( shell, SWT.PUSH );
       b.setText( "Show Next Button" );
       final int[] index = new int[ 1 ];
       b.addListener( SWT.Selection, new Listener() {

         public void handleEvent( Event e ) {
           index[ 0 ] = ( index[ 0 ] + 1 ) % 10;
           layout.topControl = bArray[ index[ 0 ] ];
           parent.layout();
         }
       } );
       shell.open();
       while( shell != null && !shell.isDisposed() ) {
         if( !display.readAndDispatch() )
           display.sleep();
       }
     }

### Field Summary

Fields
`int` `marginHeight` marginHeight specifies the number of pixels of vertical margin that will be placed along the top and bottom edges of the layout.
`int` `marginWidth` marginWidth specifies the number of pixels of horizontal margin that will be placed along the left and right edges of the layout.
`Control` `topControl` topControl the Control that is displayed at the top of the stack.

### Constructor Summary

Constructors
`StackLayout()`

### Method Summary

All Methods Instance Methods Concrete Methods
`protected Point` `computeSize​(Composite composite, int wHint, int hHint, boolean flushCache)` Computes and returns the size of the specified composite's client area according to this layout.
`protected boolean` `flushCache​(Control control)` Instruct the layout to flush any cached values associated with the control specified in the argument `control`.
`protected void` `layout​(Composite composite, boolean flushCache)` Lays out the children of the specified composite according to this layout.
`java.lang.String` `toString()` Returns a string containing a concise, human-readable description of the receiver.

### Methods inherited from class java.lang.Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

### Field Detail

#### marginWidth

    public int marginWidth

marginWidth specifies the number of pixels of horizontal margin that will be placed along the left and right edges of the layout. The default value is 0.

#### marginHeight

    public int marginHeight

marginHeight specifies the number of pixels of vertical margin that will be placed along the top and bottom edges of the layout. The default value is 0.

#### topControl

    public Control topControl

topControl the Control that is displayed at the top of the stack. All other controls that are children of the parent composite will not be visible.

### Constructor Detail

#### StackLayout

    public StackLayout()

### Method Detail

#### computeSize

    protected Point computeSize​(Composite composite,
                                int wHint,
                                int hHint,
                                boolean flushCache)

Description copied from class: `Layout`
Computes and returns the size of the specified composite's client area according to this layout.

This method computes the size that the client area of the composite must be in order to position all children at their preferred size inside the composite according to the layout algorithm encoded by this layout.

When a width or height hint is supplied, it is used to constrain the result. For example, if a width hint is provided that is less than the width of the client area, the layout may choose to wrap and increase height, clip, overlap, or otherwise constrain the children.

Specified by:
  `computeSize` in class `Layout`
Parameters:
  `composite` - a composite widget using this layout
  `wHint` - width (`SWT.DEFAULT` for preferred size)
  `hHint` - height (`SWT.DEFAULT` for preferred size)
  `flushCache` - `true` means flush cached layout values
Returns:
  a point containing the computed size (width, height)
See Also:
  `Layout.layout(org.eclipse.swt.widgets.Composite, boolean)`, `Control.getBorderWidth()`, `Control.getBounds()`, `Control.getSize()`, `Control.pack(boolean)`, "computeTrim, getClientArea for controls that implement them"

#### flushCache

    protected boolean flushCache​(Control control)

Description copied from class: `Layout`
Instruct the layout to flush any cached values associated with the control specified in the argument `control`.

Overrides:
  `flushCache` in class `Layout`
Parameters:
  `control` - a control managed by this layout
Returns:
  true if the Layout has flushed all cached information associated with control

#### layout

    protected void layout​(Composite composite,
                          boolean flushCache)

Description copied from class: `Layout`
Lays out the children of the specified composite according to this layout.

This method positions and sizes the children of a composite using the layout algorithm encoded by this layout. Children of the composite are positioned in the client area of the composite. The position of the composite is not altered by this method.

When the flush cache hint is true, the layout is instructed to flush any cached values associated with the children. Typically, a layout will cache the preferred sizes of the children to avoid the expense of computing these values each time the widget is laid out.

When layout is triggered explicitly by the programmer the flush cache hint is true. When layout is triggered by a resize, either caused by the programmer or by the user, the hint is false.

Specified by:
  `layout` in class `Layout`
Parameters:
  `composite` - a composite widget using this layout
  `flushCache` - `true` means flush cached layout values

#### toString

    public java.lang.String toString()

Returns a string containing a concise, human-readable description of the receiver.

Overrides:
  `toString` in class `java.lang.Object`
Returns:
  a string representation of the layout